#!/usr/bin/perl

# Enthral SVN: $Id: onelinerz.pl 91 2010-12-18 03:58:04Z frank $
# Source: $HeadURL$
# $LastChangedDate: 2010-12-17 22:58:04 -0500 (Fri, 17 Dec 2010) $
# $LastChangedRevision: 91 $
# $LastChangedBy: frank $

# bbs-scene.org global onelinerz
# written by Frank Linhares aka Netsurge
# frank@bbs-scene.org
#
# Pass the user's alias on the commandline like this:
#
# ./onelinerz.pl "users_alias"
#

# Load config
my $config_file = "onelinerz.cfg";
open CONFIG, "$config_file"
  or die
  "Program stopping, couldn't open the configuration file '$config_file'.\n";
my $config = join "", <CONFIG>;
close CONFIG;
eval $config;
die
"Couldn't interpret the configuration file ($config_file) that was given.\nError details follow: $@\n"
  if $@;

# Check for LWP::UserAgent and XML::Simple modules
eval { use LWP::UserAgent; };
if ($@) {
    print "You need the LWP::UserAgent module installed.\r\n";
    exit;
}

eval { use XML::Simple; };
if ($@) {
    print "You need the XML::Simple module installed.\r\n";
    exit;
}

# Init Variables

$ESC = "\e";
$Ansi_Codes{'Black'} = $ESC."[0;30m";
$Ansi_Codes{'Blue'} = $ESC."[0;34m";
$Ansi_Codes{'Green'} = $ESC."[0;32m";
$Ansi_Codes{'Cyan'} = $ESC."[0;36m";
$Ansi_Codes{'Red'} = $ESC."[0;31m";
$Ansi_Codes{'Magenta'} = $ESC."[0;35m";
$Ansi_Codes{'Brown'} = $ESC."[0;35m";
$Ansi_Codes{'Lt Grey'} = $ESC."[0;37m";
$Ansi_Codes{'Grey'} = $ESC."[1;30m";
$Ansi_Codes{'Lt Blue'} = $ESC."[1;34m";
$Ansi_Codes{'Lt Green'} = $ESC."[1;32m";
$Ansi_Codes{'Lt Cyan'} = $ESC."[1;36m";
$Ansi_Codes{'Lt Red'} = $ESC."[1;31m";
$Ansi_Codes{'Lt Magenta'} = $ESC."[1;35m";
$Ansi_Codes{'Yellow'} = $ESC."[1;33m";
$Ansi_Codes{'White'} = $ESC."[1;37m";
$Ansi_Codes{'Bk Black'} = $ESC."[40m";
$Ansi_Codes{'Bk Blue'} = $ESC."[44m";
$Ansi_Codes{'Bk Green'} = $ESC."[42m";
$Ansi_Codes{'Bk Cyan'} = $ESC."[46m";
$Ansi_Codes{'Bk Red'} = $ESC."[41m";
$Ansi_Codes{'Bk Magenta'} = $ESC."[45m";
$Ansi_Codes{'Bk Brown'} = $ESC."[43m";
$Ansi_Codes{'Bk Grey'} = $ESC."[47m";

# User input backspaces
system("stty erase ^H");

$oheader = $linerzpath . "/" . $header;
my $url = "http://bbs-scene.org/api/onelinerz.php?limit";
my $api = $url . "=" . $limit;

my $xmlresponse = &bbssceneApiGet( $username, $password, $api );

# Display Header
open( FILE, "< $oheader" ) or die "Can't open $header : $!";

while (<FILE>) {
    print;
}

close FILE;
print
"\e[30;1m-------------------------------------------------------------------------------\n";

# create xml object
$xml = new XML::Simple( KeyAttr => [] );

#&stripIllegal($xml);


# read XML file
$data = $xml->XMLin("$xmlresponse") or die "Can't process onelinerz.xml : $!";


my $i = 0;

# access <node> array
foreach $e ( @{ $data->{node} } ) {

    $oneliner =
        " \e[30;1m(\e[37;1m"
      . $e->{alias}
      . "\e[34;1m/\e[36;1m"
      . $e->{bbsname}
      . "\e[30;1m) \e[30;0m"
      . $e->{oneliner};

    #Convert Pipe codes to Escape Codes
    
    $oneliner =~ s/\|00/$Ansi_Codes{'Black'}/;
    $oneliner =~ s/\|01/$Ansi_Codes{'Blue'}/;
    $oneliner =~ s/\|02/$Ansi_Codes{'Green'}/;
    $oneliner =~ s/\|03/$Ansi_Codes{'Cyan'}/;
    $oneliner =~ s/\|04/$Ansi_Codes{'Red'}/;
    $oneliner =~ s/\|05/$Ansi_Codes{'Magenta'}/;
    $oneliner =~ s/\|06/$Ansi_Codes{'Brown'}/;
    $oneliner =~ s/\|07/$Ansi_Codes{'Lt Grey'}/;
    $oneliner =~ s/\|08/$Ansi_Codes{'Grey'}/;
    $oneliner =~ s/\|09/$Ansi_Codes{'Lt Blue'}/;
    $oneliner =~ s/\|10/$Ansi_Codes{'Lt Green'}/;
    $oneliner =~ s/\|11/$Ansi_Codes{'Lt Cyan'}/;
    $oneliner =~ s/\|12/$Ansi_Codes{'Lt Red'}/;
    $oneliner =~ s/\|13/$Ansi_Codes{'Lt Magenta'}/;
    $oneliner =~ s/\|14/$Ansi_Codes{'Yellow'}/;
    $oneliner =~ s/\|15/$Ansi_Codes{'White'}/;
    $oneliner =~ s/\|16/$Ansi_Codes{'Bk Black'}/;
    $oneliner =~ s/\|17/$Ansi_Codes{'Bk Blue'}/;
    $oneliner =~ s/\|18/$Ansi_Codes{'Bk Green'}/;
    $oneliner =~ s/\|19/$Ansi_Codes{'Bk Cyan'}/;
    $oneliner =~ s/\|20/$Ansi_Codes{'Bk Red'}/;
    $oneliner =~ s/\|21/$Ansi_Codes{'Bk Magenta'}/;
    $oneliner =~ s/\|22/$Ansi_Codes{'Bk Brown'}/;
    $oneliner =~ s/\|23/$Ansi_Codes{'Bk Grey'}/;
    $oneliner =~ s/\|24/$Ansi_Codes{'Black'}/;
     
    # Limit line length 
    $oneliner = substr( $oneliner, 0, 121 );

    print $oneliner . "\n";

    # Increment the loop counter
    $i++;

    # Check if we've hit the limit
    if ( $i >= $limit ) {

        # Leave the loop
        last;
    }
}

# Print footer
print
"\e[30;1m-------------------------------------------------------------------------------\n";

# If matches no user
if ( grep /^$ARGV[$0]$/i, @twit ) {

    print "\e[30;0myou're not allowed to post a oneliner.\n";

    sleep 3;
    print "\e[2J";
    exit 0;

}
else {

    # Add a oneliner ?
    $addliner = &promptUser(
"\e[30;0madd a oneliner to bbs-scene.org \e[30;1m.\e[37;1my\e[30;1m/\e[37;1mn\e[30;1m. "
    );

    # Process answer
    if ( $addliner =~ m/y/ ) {
        $response = oneliner();
        &bbssceneApiPost( $username, $password, $bbsname, $ARGV[$0],
            $response );
        print "\e[2J";
    }
    else {
        print "\e[2J";
        exit 0;
    }
}

sub stripIllegal {
    my ($input) = @_;

    # allowed: [#x1-#xD7FF] | [#xE000-#xFFFD] | [#x10000-#x10FFFF]
    $input =~ s/[^\x01-\x{D7FF}\x{E000}-\x{FFFD}\x{10000}-\x{10FFFF}]//go;

    # restricted:[#x1-#x8][#xB-#xC][#xE-#x1F][#x7F-#x84][#x86-#x9F]
    $input =~ s/[\x01-\x08\x0B-\x0C\x0E-\x1F\x7F-\x84\x86-\x9F]//go;

    # Strip any backslashes and illegal characters from the user input
    $input =~ s/\\\\([^\\\\])/$1/g;
}

sub promptUser {
    my ( $prompt, $default ) = @_;
    my $defaultValue = $default ? "[$default]" : "";
    print "$prompt$defaultValue: ";
    chomp( my $input = <STDIN> );
    return $input ? $input : $default;
}

sub oneliner {

    # Prompt for oneliner
    $oneliner = &promptUser("");

    # If oneliner is empty clear screen then exit
    if ( $oneliner eq "" ) {
        print "\e[2J";
        exit 0;
    }

    &stripIllegal($oneliner);
    return $oneliner;
}

sub bbssceneApiGet {
    my ( $username, $password, $api ) = @_;
    my $entrybrowser = LWP::UserAgent->new;
    $entrybrowser->agent('bbssceneapi/1.01');
    $entrybrowser->timeout(2);
    $entrybrowser->credentials(
        'bbs-scene.org:80',
        'bbs-scene.org api',
        $username => $password
    );
    my $entry = $entrybrowser->get($api);
    $output = $entry->decoded_content;
    return $output;
}

sub bbssceneApiPost {
    my ( $username, $password, $bbsname, $alias, $oneliner ) = @_;
    my $postbrowser = new LWP::UserAgent;
    $postbrowser->agent('bbssceneapi/1.01');
    $postbrowser->timeout(2);
    $postbrowser->credentials(
        'bbs-scene.org:80',
        'bbs-scene.org api',
        $username => $password
    );
    my $post = $postbrowser->post(
        'http://bbs-scene.org/api/onelinerz.xml',
        {
            bbsname  => $bbsname,
            alias    => $alias,
            oneliner => $oneliner,
        }
    );
}
